/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        AbsException: a C++ parent class for all request exceptions
        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: AbsException.h,v 1.8 2005/05/19 15:42:46 adorigo Exp $
*/

#ifndef __ABSEXCEPTION_H__
#define __ABSEXCEPTION_H__

#include <string>
/// Base class for all faults not generated by CEMonitor.
/**
        This class is the base for all SOAP faults not generated by the CEMonitor services.\n
	This class is not instantiable.
	\sa ServiceNotFoundException
	\sa GeneralException
	\sa AuthenticationException
*/
class AbsException
{
 private:
  std::string cause;

 protected:
  AbsException(const std::string&) throw();
  AbsException() throw();
  AbsException operator=(const AbsException&){ return *this; } //prevent copy

 public:
  /// Deletes an AbsException object
  virtual ~AbsException() throw() {}
  /// Returns info about fault
  /**
	Returns detailed and human readable informations about the fault
  */
  virtual const char* what() const throw() { return cause.c_str(); }
};

#endif
