/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        Action: a wrapper class to handle actions

        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: Action.h,v 1.9 2005/10/04 09:31:54 adorigo Exp $
*/

#ifndef __ACTION_H__
#define __ACTION_H__

#include "glite/ce/monitor-client-api-c/monitor_client_soapStub.h"
#include "glite/ce/monitor-client-api-c/Parameter.h"
#include "glite/ce/monitor-client-api-c/Property.h"
#include <string>

#define ACTION _ns2__Action

class CEEvent;
class CESubscription;
class Policy;
class CEInfo;

class ActionW : public ACTION {

  friend class CEEvent;
  friend class CEInfo;
  friend class CESubscription;
  friend class Policy;

 protected:
  ActionW(const ACTION&);
  ActionW& operator=(const ActionW&);

 public:
  ActionW(const std::string& Name, const std::string& type, const bool& doActionWhenQueryIs);
  virtual ~ActionW(void);

  std::string  getActionName(void) const;
  std::string  getActionType(void) const;
  bool         getPerformAction(void) const;
  int          addParameter(ParameterW*);
  int          getNumberOfParameters(void) const;
  int          getNumberOfProperties(void) const;
  ParameterW*  getParameterAt(const int&) const;
  PropertyW*   getPropertyAt(const int&) const;
  //std::string  getJarPath(void) const;
  int          getActionID(void) const;
  void         print(void) const;
};

#endif
