/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        AuthenticationException: a C++ Exception related to "AuthenticationFault" response from CEMon
        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: AuthenticationException.h,v 1.6 2005/05/10 14:19:24 adorigo Exp $
*/


#ifndef __AUTHEXCEPTION_H__
#define __AUTHEXCEPTION_H__

#include "glite/ce/monitor-client-api-c/AbsException.h"
#include <string>

/// Exception for authentication-related faults
/**
	An object of this class is usually raised when the SSL setup of SOAP
	runtime fails (certificate corrupted), or when the user provides a non existing proxy file certificate or a unreadable one. Or, finally, when the certificate itself is expired.
*/
class AuthenticationException : public AbsException
{
 public:
 /// Creates an AuthenticationException with an error message
  AuthenticationException(const std::string&);

 protected:
  AuthenticationException& operator=(const AuthenticationException&) { return *this; } // prevent copy
};

#endif
