/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        CEException: a C++ Exception related to any CE-generated fault
        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: CEException.h,v 1.9 2005/09/27 09:14:21 zangran Exp $
*/

#ifndef __CEEXCEPTION_H__
#define __CEEXCEPTION_H__

#include <string>
#include <time.h>

class CEException
{

 private:
  std::string MethodName;
  std::string ErrorCode;
  std::string Description;
  std::string FaultCause;
  time_t Timestamp;

 public:

  enum {
    Subscription = 9,
    TopicNotSupported = 10,
    DialectNotSupported = 11,
    Base = 26,
    Generic = 27,
    Authentication = 28,
    Authorization = 29
  };

  CEException(const std::string&, const time_t&, const std::string&, const std::string&, const std::string&);
  CEException() {}
  virtual ~CEException() {}
  //inline virtual const char* what() const throw() { return completeError.c_str(); }
  inline virtual const char* what() const throw();// { return completeError.c_str(); }
  inline std::string getMethod() { return MethodName; }
  inline std::string getErrorCode() { return ErrorCode; }
  inline std::string getDescription() { return Description; }
  inline std::string getFaultCause() { return FaultCause; }
  inline time_t      getTimeStamp() { return Timestamp; }

 protected:
  CEException& operator=(const CEException&) { return *this; } // prevent copy
  //CEException(const CEException&) {} // prevent copy
};

#endif
