
/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        CETopics.hh: header file for a C++ class wrapping the GetTopics call

        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: CETopics.h,v 1.23 2005/10/04 09:31:54 adorigo Exp $
*/

#ifndef __CETOPICS__
#define __CETOPICS__

#include "glite/ce/monitor-client-api-c/AbsRequest.h"
#include "glite/ce/monitor-client-api-c/Topic.h"
#include <string>
#include <vector>

using namespace std;

#define GETTOPICSRESP ns1__GetTopicsResponse
#define TOPICARRAY _ns2__TopicArray
#define TOPICARRAY_FIELD ns2__TopicArray
#define GETTOPIC soap_call_ns1__GetTopics

class CETopics : public AbsRequest {
  
 private:
  bool retrievedTopics;
  GETTOPICSRESP topicResp;
  //vector<TOPIC*> *topic;
  int sizeTopic, topicCounter;
  
 protected:
  CETopics(const CETopics&) {}
  CETopics& operator=(const CETopics&) { return *this; }

public:

  CETopics(const std::string, const std::string) throw(AuthenticationException&, GeneralException&);
  virtual ~CETopics();

  void getTopicArray(vector<Topic*> *) const;
  int getNumberOfTopics(void) const;
  void getTopics(void) throw(GenericException&, 
			     TopicNotSupportedException&, 
			     DialectNotSupportedException&, 
			     SubscriptionException&, 
			     ServiceNotFoundException&, 
			     GeneralException&);
};

#endif
