/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        Dialect: a wrapper class to handle dialects

        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: Dialect.h,v 1.9 2005/10/04 09:31:54 adorigo Exp $
*/

#ifndef __DIALECT_H__
#define __DIALECT_H__

#include "glite/ce/monitor-client-api-c/monitor_client_soapStub.h"
#include <string>


#define DIALECT _ns2__Dialect

class CEEvent;
class CESubscription;
class Topic;

class DialectW : public DIALECT {

  friend class CEEvent;
  friend class Topic;
  friend class CESubscription;
  
 protected:
  DialectW(const DIALECT&);
  virtual ~DialectW(void) throw(); // I do not want that the user can delete this class. Only Topic can do it. Why?
				   // Because Topic::addDialect() copy a pointer variable to a dialect and pushes
				   // it into a vector. Then, when Topic is called it wants to delete each element of
				   // that vector by delet-ing it. But what if somebody else deleted the same pointer ?
				   // So, I decided that only Topic class can delete DialectW elements.
  DialectW& operator=(const DialectW& dial);

 public:
  DialectW(const std::string& name);
  
  int         getNumberOfQueryLanguages(void) const;
  std::string getQueryLanguageAt(const int&) const;
  std::string getDialectName(void) const;
  void        setDialectName(const std::string&);
  void        setQueryLanguageAt(const int&, const std::string&);
  int         addQueryLanguage(const std::string);
  void        print(void);
};

#endif
