/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        Parameter: a class to handle parameters for actions

        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: Parameter.h,v 1.7 2005/10/04 09:31:54 adorigo Exp $
*/

#ifndef __PARAMETER_H__
#define __PARAMETER_H__

#include "glite/ce/monitor-client-api-c/monitor_client_soapStub.h"
#include <string>
#include <iostream>

#define PARAMETER _ns2__Parameter

class CEEvent;
class CESubscription;
class ActionW;

class ParameterW : public PARAMETER {

   friend class CEEvent;
   friend class CESubscription;
   friend class ActionW;
   
/* private: */
/*    PARAMETER param; */
   
protected:
   ParameterW(const PARAMETER&);
   ParameterW& operator=(const ParameterW&);

public:
   ParameterW(const std::string& p, const std::string& pval);
   virtual ~ParameterW() {std::cerr<<"~ParameterW..."<<std::endl;}
   std::string getParameterName(void) const;
   std::string getParameterValue(void) const;
   void        setParameterName(const std::string& name);
   void        setParameterValue(const std::string& val);
};

#endif
