/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        Policy: a class to handle policy

        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: Policy.h,v 1.6 2005/10/04 09:31:54 adorigo Exp $
*/

#ifndef __POLICY_H__
#define __POLICY_H__

#include "glite/ce/monitor-client-api-c/monitor_client_soapStub.h"
#include "glite/ce/monitor-client-api-c/Action.h"
#include "glite/ce/monitor-client-api-c/Query.h"
#include <vector>

#define POLICY _ns2__Policy

class CESubscription;

class Policy : public POLICY {
  
  friend class CESubscription;

 protected:
  Policy(const POLICY&);

 public:
  Policy(const int& rate);
  virtual ~Policy();
  Policy& operator=(const Policy&);
  int addAction_Query(ActionW*, QueryW*);
  ActionW* getActionAt(const int& index);
  void print(void) const;
};

#endif
