/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        Query: a class to handle Query

        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: Query.h,v 1.7 2005/10/04 09:31:54 adorigo Exp $
*/

#ifndef __QUERY_H__
#define __QUERY_H__

#include "glite/ce/monitor-client-api-c/monitor_client_soapStub.h"
#include <string>

#define QUERY _ns2__Query

class Policy;

class QueryW : public QUERY {

   friend class Policy;

 protected:
   QueryW(const QUERY&);
   QueryW& operator=(const QueryW&);

public:
   QueryW();
   QueryW(const std::string&, const std::string&);
   virtual ~QueryW() {}
   std::string getExpression(void) const;
   std::string getQueryLanguage(void) const;
   void        setExpression(const std::string&);
   void        setQueryLanguage(const std::string&);
};

#endif
