/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        Topic: a class to handle topic

        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: Topic.h,v 1.9 2005/10/04 09:31:54 adorigo Exp $
*/

#ifndef __TOPIC_H__
#define __TOPIC_H__

#include "glite/ce/monitor-client-api-c/monitor_client_soapStub.h"
#include "glite/ce/monitor-client-api-c/Dialect.h"
#include <string>

#define TOPIC _ns2__Topic

class CEEvent;
class CESubscription;
class CETopics;

class Topic : public TOPIC {

  friend class CEEvent;
  friend class CEInfo;
  friend class CESubscription;
  friend class CETopics;
  friend class CEConsumer;

  Topic& operator=(const Topic&);

 protected:
  Topic(const TOPIC&);

 public:
  Topic(const std::string&);
  
  virtual ~Topic();
  int addDialect(DialectW*);
  DialectW* getDialectAt(const int&);
  int getNumOfDialects(void) const;
  std::vector<DialectW*> getDialects(void) const;
  void print(void) const;
};

#endif
